import java.util.*;

public class LaunchSingletons implements Runnable
{
    private static final long LOOPS = 1000000;
    
    @Override
    public void run()
    {
        Singleton singleton = null;
        for (long i = 0; i < LOOPS; i++)
            singleton = Singleton.getInstance();
        System.out.println(singleton);
    }
    
    public static void main(String [] args)
    {
        final int N = Integer.parseInt(args[0]);
    
        List<Thread> threads = new ArrayList<Thread>();
        
        long start = (new Date()).getTime();        
        for (int i = 0; i < N; i++)
        {
            Thread t = new Thread(new LaunchSingletons());
            t.start();
            threads.add(t);
        }

        for (Thread t : threads)
        {
            try
            {
                t.join();
            }
            catch (InterruptedException e)
            {
                e.printStackTrace();
            }
        }
        System.out.println("Time (ms): " + ((new Date()).getTime() - start));
        
    }
    
}
